/*
google.c - Google hack for RSStool

Copyright (c) 2006 NoisyB


This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#ifdef  HAVE_CONFIG_H
#include "config.h"
#endif
#include <stdio.h>
#include <time.h>
#include "misc/net.h"
#include "misc/string.h"
#include "misc/rss.h"
#include "misc/file.h"
#include "rsstool_defines.h"
#include "rsstool.h"
#include "rsstool_misc.h"
#include "google.h"


#define GOOGLE_URL_S "http://www.google.com"
#define GOOGLE_RSS_S GOOGLE_URL_S "/search?q=allinurl:rss+filetype:xml+-html+-php+-htm&num=100"
#define GOOGLE_RSS_LANG_S "&lr=lang_%s"
#define GOOGLE_RSS_START_S "&start=%d&sa=N"


static char buffer[MAXBUFSIZE];


static const char *
a_filter (const char *s)
{
  const char *p = NULL;

  p = net_tag_get_value (s, "class");
  if (!p)
    return "";

  if (stricmp (p, "l"))
    return "";

  p = net_tag_get_value (s, "href");
  if (!p)
    return "";

  if (stristr (p, "xml"))
    printf ("%s\n", p);

  return "";
}


st_tag_filter_t google_item_filter[] = {
  {
    "a",
    a_filter
  },
  {NULL, NULL}
};


int
hack_google (st_rsstool_t *rt, const char *lang)
{
  (void) rt;
  st_net_t *n = NULL;
  char buf[MAXBUFSIZE];
  char *p = NULL;
  int cf = 0;
  int count = 0;

  if (!(n = net_init (0)))
    {
      fprintf (stderr, "ERROR: google_get_rss()/net_init() failed\n");
      return -1;
    }

  for (count = 0; ; count += 100)
    {
      if (net_open (n, GOOGLE_URL_S, 80) != 0)
        {
          fprintf (stderr, "ERROR: could not log on to %s\n", GOOGLE_URL_S);
          return -1;
        }

      strcpy (buf, GOOGLE_RSS_S);
      sprintf (strchr (buf, 0), GOOGLE_RSS_LANG_S, lang); 
      if (count)
        sprintf (strchr (buf, 0), GOOGLE_RSS_START_S, count);

#ifdef  DEBUG
      printf ("\n\n%s\n\n", buf);
#endif

      p = net_build_http_request (buf, rsstool.user_agent, 0, NET_METHOD_GET, 0);
      net_write (n, (char *) p, strlen (p));

      while (net_gets (n, buf, MAXBUFSIZE))
        {
          p = strchr (buf, '\n');
          if (p)
            *p = 0;

          strncpy (buffer, buf, MAXBUFSIZE)[MAXBUFSIZE - 1] = 0;
          cf = net_tag_filter (buf, google_item_filter, cf);
        }

      net_close (n);
    }

  net_quit (n);

  return 0;
}
